

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.4. grn_cache &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.25.5. grn_column" href="grn_column.html" />
    <link rel="prev" title="7.25.3. Plugin" href="plugin.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/api/grn_cache.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="grn_column.html" title="7.25.5. grn_column"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="plugin.html" title="7.25.3. Plugin"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-cache">
<h1><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code><a class="headerlink" href="#grn-cache" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.4.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This API is experimental.</p>
</div>
<p><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> is a data store that keeps responses of
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command. It is not general use cache
object. It is only for <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command.</p>
<p>You can just change the current cache object by
<a class="reference internal" href="#c.grn_cache_current_set" title="grn_cache_current_set"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_current_set()</span></code></a>. <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a>
command response cache is done internally.</p>
<p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command uses one global cache
object. If you open multiple databases, the one cache is shared. It is
an important problem.</p>
<p>If you open multiple databases and use
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command, you need to use
<code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> object. It is <a class="reference internal" href="../executables/groonga-httpd.html"><span class="doc">groonga-httpd</span></a>
case. If you open only one database or don’t use
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command, you don’t need to use
<code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> object. It is <a class="reference external" href="http://ranguba.org/#about-rroonga">rroonga</a> case.</p>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.4.2. </span>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>Here is an example that change the current cache object.</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_cache</span> <span class="o">*</span><span class="n">cache</span><span class="p">;</span>
<span class="n">grn_cache</span> <span class="o">*</span><span class="n">cache_previous</span><span class="p">;</span>
<span class="n">cache</span> <span class="o">=</span> <span class="n">grn_cache_open</span><span class="p">(</span><span class="n">ctx</span><span class="p">);</span>
<span class="n">cache_previous</span> <span class="o">=</span> <span class="n">grn_cache_current_get</span><span class="p">(</span><span class="n">ctx</span><span class="p">);</span>
<span class="n">grn_cache_current_set</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">cache</span><span class="p">);</span>
<span class="cm">/* grn_ctx_send(ctx, ...); */</span>
<span class="n">grn_cache_current_set</span><span class="p">(</span><span class="n">ctx</span><span class="p">,</span> <span class="n">cache_previous</span><span class="p">);</span>
</pre></div>
</div>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.4.3. </span>Reference<a class="headerlink" href="#reference" title="Permalink to this headline">¶</a></h2>
<dl class="c type">
<dt id="c.grn_cache">
<em class="property">type </em><code class="sig-name descname">grn_cache</code><a class="headerlink" href="#c.grn_cache" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>It is an opaque cache object. You can create a <code class="docutils literal notranslate"><span class="pre">grn_cache</span></code> by
<a class="reference internal" href="#c.grn_cache_open" title="grn_cache_open"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_open()</span></code></a> and free the created object by
<a class="reference internal" href="#c.grn_cache_close" title="grn_cache_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_close()</span></code></a>.</p>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_open">
<a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<code class="sig-name descname">grn_cache_open</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_open" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Creates a new cache object.</p>
<p>If memory allocation for the new cache object is failed, <code class="docutils literal notranslate"><span class="pre">NULL</span></code>
is returned. Error information is stored into the <code class="docutils literal notranslate"><span class="pre">ctx</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>A newly allocated cache object on success, <code class="docutils literal notranslate"><span class="pre">NULL</span></code>
otherwise. The returned cache object must be freed by
<a class="reference internal" href="#c.grn_cache_close" title="grn_cache_close"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_cache_close()</span></code></a>.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_close">
grn_rc <code class="sig-name descname">grn_cache_close</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_close" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Frees resourses of the <code class="docutils literal notranslate"><span class="pre">cache</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
<li><p><strong>cache</strong> – The cache object to be freed.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> otherwise.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_current_set">
grn_rc <code class="sig-name descname">grn_cache_current_set</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_current_set" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Sets the cache object that is used in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
<li><p><strong>cache</strong> – The cache object that is used in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> otherwise.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_current_get">
<a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<code class="sig-name descname">grn_cache_current_get</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_current_get" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Gets the cache object that is used in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The cache object that is used in
<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> command. It may be <code class="docutils literal notranslate"><span class="pre">NULL</span></code>.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_set_max_n_entries">
grn_rc <code class="sig-name descname">grn_cache_set_max_n_entries</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em>, unsigned int <em>n</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_set_max_n_entries" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Sets the max number of entries of the cache object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
<li><p><strong>cache</strong> – The cache object to be changed.</p></li>
<li><p><strong>n</strong> – The new max number of entries of the cache object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> on success, not <code class="docutils literal notranslate"><span class="pre">GRN_SUCCESS</span></code> otherwise.</p>
</dd>
</dl>
</dd></dl>

<dl class="c function">
<dt id="c.grn_cache_get_max_n_entries">
unsigned int <code class="sig-name descname">grn_cache_get_max_n_entries</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="#c.grn_cache" title="grn_cache">grn_cache</a> *<em>cache</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_cache_get_max_n_entries" title="Permalink to this definition">¶</a><br /></dt>
<dd><p>Gets the max number of entries of the cache object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context.</p></li>
<li><p><strong>cache</strong> – The target cache object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>The max number of entries of the cache object.</p>
</dd>
</dl>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.4. <code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.4.1. Summary</a></li>
<li><a class="reference internal" href="#example">7.25.4.2. Example</a></li>
<li><a class="reference internal" href="#reference">7.25.4.3. Reference</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="plugin.html"
                        title="previous chapter"><span class="section-number">7.25.3. </span>Plugin</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="grn_column.html"
                        title="next chapter"><span class="section-number">7.25.5. </span><code class="docutils literal notranslate"><span class="pre">grn_column</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="grn_column.html" title="7.25.5. grn_column"
             >next</a> |</li>
        <li class="right" >
          <a href="plugin.html" title="7.25.3. Plugin"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.4. </span><code class="docutils literal notranslate"><span class="pre">grn_cache</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>